
Redmine - Patch #2482

Named scopes in Issue and ActsAsWatchable plus some view refactoring (logic extraction).

2009-01-09 18:15 - Nikos Dimitrakopoulos

Status: Closed Start date: 2009-01-09

Priority: Normal Due date:  

Assignee: Eric Davis % Done: 100%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 1.0.0 (RC)   

Description

Added named_scope in Issue and ActsAsWatchable replacing custom finder method declarations in model classes and custom find

queries in views.

More specifically this patch introduces the following changes:

Replaces watched_by class method in ActsAsWatchable with a named_scope of the same name (so no API breaking)

Adds Issue::recently_updated, Issue::with_limit and Issue::on_active_project which are optional but handy. If they seem

reduntant they can be removed and update the views accordingly (see next bullet)

Removes DB logic from partial view my/blocks/_issueswatched.rhtml which falls back to new named scopes. It would be

even better if this thing was inside the controller (that is the right place) but because of the modularity of my/page (due to the

blocks) I didn't touch it.

plus:

Tests for introduced changes

and

Minor documentation for introduced changes

Patch is against trunk r2250.

Note: If you find it useful I could also refactor other parts of redmine, replacing custom finders with named scopes (if possible) and

extracting model logic from views. Just let me know, or simply apply this patch :)

Associated revisions

Revision 3557 - 2010-03-10 06:10 - Eric Davis

Adds named scopes to replace custom finders.

Adds watched_by class method in ActsAsWatchable

Adds Issue#recently_updated, Issue#with_limit and Issue#on_active_project   

#2482

History

#1 - 2009-01-09 23:26 - Eric Davis

- Assignee set to Eric Davis

I'll take a look at this patch and see about appling.

Note: If you find it useful I could also refactor other parts of redmine, replacing custom finders with named scopes (if possible) and extracting

model logic from views. Just let me know, or simply apply this patch :)

 I would find that really useful.  I've been waiting for 0.8 to be released before I went through refactoring.  If you use git, could you branch from my 

GitHub repository and send me the patches through GitHub?  It makes it easy to review and apply them.

Thanks
https://www.redmine.org/projects/redmine/repository/svn/revisions/2250
http://github.com/edavis10/redmine/tree/master


#2 - 2009-01-26 03:05 - Eric Davis

- Status changed from New to 7

http://github.com/nikosd/redmine/commit/d5d84e8f859be8873be76589b2814b567cac2fce

#3 - 2010-03-10 06:11 - Eric Davis

- Category set to Code cleanup/refactoring

- Status changed from 7 to Closed

- Target version set to 1.0.0 (RC)

- % Done changed from 0 to 100

Committed in r3557
